SystemOrganization addCategory: #'CS528su13AES-HW5'!

Object subclass: #Scripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13AES-HW5'!

!Scripts methodsFor: 'countWords' stamp: 'EricShahkarami 6/21/2013 14:10'!
countWordsIn: filename 
	| fs wordStream wordOccurrences | 
	fs := FileStream readOnlyFileFullyNamed: filename.
	wordStream := WordStream on: (fs contents).
	
	wordOccurrences := Bag new.
	
	wordStream do: [ :word | wordOccurrences add: word ].
	^(wordOccurrences sortedCounts).! !

!Scripts methodsFor: 'dollarWords' stamp: 'ShruthiSudhanva 6/20/2013 00:18'!
dollarWords: aFile
	| fs wordStream dollarWords | 
	fs := FileStream readOnlyFileFullyNamed: aFile.
	wordStream := WordStream on: (fs contents).
	dollarWords := Set new.
	
	wordStream do: [ :word | (self getWordWorth: word) = 100
		ifTrue: [ dollarWords add: word ]
		 ].
	^dollarWords .! !

!Scripts methodsFor: 'dollarWords' stamp: 'ShruthiSudhanva 6/19/2013 21:54'!
getCharacterWorth: aCharacter
	aCharacter isUppercase 
	ifTrue:[ ^aCharacter asciiValue - 64]
	ifFalse:[ ^aCharacter asciiValue - 96]
	! !

!Scripts methodsFor: 'dollarWords' stamp: 'ShruthiSudhanva 6/19/2013 21:55'!
getWordWorth: aWord
	^aWord inject:0 into:[:wordWorth :character | wordWorth + (self getCharacterWorth: character) ]! !

TestCase subclass: #WordStreamTest
	instanceVariableNames: 'wordStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13AES-HW5'!

!WordStreamTest methodsFor: 'testing' stamp: 'EricShahkarami 6/19/2013 19:25'!
testDo
	| aString numbers |
	
	numbers := Set new.
	aString := 'This is a string with numbers in it like 42. Here is another number 119. The number 789 is odd.'.
	wordStream := WordStream on: aString.
	wordStream do: [ :word | word isAllDigits ifTrue: [ numbers add: word asNumber ] ].
	Transcript show: numbers.
	self assert: numbers = (Set newFrom: #(42 119 789))! !

!WordStreamTest methodsFor: 'testing' stamp: 'EricShahkarami 6/19/2013 19:10'!
testNumberOfElements
	| orderedElements |
	
	orderedElements := OrderedCollection newFrom: #('hello' 'world').
	self assert: ((WordStream on: 'hello world') next: 3) = orderedElements.
	self assert: ((WordStream on: ' hello world') next: 3) = orderedElements.
	self assert: ((WordStream on: 'hello world ') next: 3) = orderedElements.
	self assert: ((WordStream on: 'hello  world') next: 3) = orderedElements! !

!WordStreamTest methodsFor: 'testing' stamp: 'EricShahkarami 6/19/2013 18:54'!
testWordsInFile
	| fs wordCount |
	
	fs := FileStream readOnlyFileFullyNamed: '/Users/eshkrm/Documents/Classes/Summer 2013/CS 528/Assignments/wordstream.txt'.
	wordStream := WordStream on: (fs contents).
	
	wordCount := 0.
	wordStream do: [ :word | wordCount := wordCount + 1 ].
	self assert: wordCount = 11.! !

Stream subclass: #WordStream
	instanceVariableNames: 'matchStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13AES-HW5'!

!WordStream class methodsFor: 'initialize-release' stamp: 'EricShahkarami 6/19/2013 18:12'!
on: aString
	^self basicNew on: aString! !

!WordStream methodsFor: 'testing' stamp: 'EricShahkarami 6/19/2013 18:35'!
atEnd 
	^matchStream atEnd ! !

!WordStream methodsFor: 'accessing' stamp: 'EricShahkarami 6/19/2013 18:06'!
next 
	^matchStream next! !

!WordStream methodsFor: 'accessing' stamp: 'EricShahkarami 6/19/2013 18:06'!
next: anInteger
	^matchStream next: anInteger! !

!WordStream methodsFor: 'initialize-release' stamp: 'EricShahkarami 6/19/2013 18:09'!
on: aString
	| wordCollection |
	
	wordCollection := aString allRegexMatches: '\w+'.
	matchStream := ReadStream on: wordCollection! !
